/**
 * Simulation of memory management algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef LIVEMAP_H_
#define LIVEMAP_H_

#include <string>
#include "globals.h"

using namespace std;

class LiveMap
{
public:
    LiveMap() : line(MAX_BLOCKS/ROW_LENGTH + 1) {}
    virtual ~LiveMap() {}

    void init();

    void show_allocation(const char name, const int size, const int n)
    {
        paint_map(name, size, n);
    }

    void show_deallocation(const int size, const int n)
    {
        paint_map('/', size, n);
    }

    void pause();
    void print();
    void print(char *text);
    void finish();

private:
    static const int ROW_LENGTH = 100;
    int line;

    void paint_map(const char ch, const int size, const int n);
};

#endif /* LIVEMAP_H_ */
